#ifndef DSPCONTROL_H_INCLUDED
#define DSPCONTROL_H_INCLUDED

#include <qqueue.h>

class DspOut;
class DspAction;

class DspControl
{
public:
	DspControl( DspOut *dspdev );
	~DspControl( void );

	void setDefaultAction( DspAction *action );
	void queueAction( DspAction *action );
	bool queueEmpty( void ) { return actionq.isEmpty(); }
	void nukeQueue( void );

	void doTick( void );

private:
	QQueue<DspAction> actionq;
	AudioBuffer *actionbuf;
	size_t actionbufpos;
	DspAction *defaction;
	DspOut *dspout;

	void fillBuffer( void );
};

#endif // DSPCONTROL_H_INCLUDED
